package com.guozhi.elasticsearch;

import com.alibaba.fastjson.JSON;
import org.frameworkset.elasticsearch.ElasticSearchHelper;
import org.frameworkset.elasticsearch.boot.BBossESStarter;
import org.frameworkset.elasticsearch.client.ClientInterface;
import org.frameworkset.elasticsearch.client.ClientOptions;
import org.frameworkset.elasticsearch.entity.ESDatas;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

/**
 * @author LiuchangLan
 * @date 2020/10/21 17:11
 */
@SpringBootTest
public class DocDemo {

    @Resource
    private BBossESStarter bbossESStarter;

    @Test
    void test(){
//        createDoc("demo","demo");

//        delete("demo","demo","1");

        select();
    }

    /**
     * @description 添加\修改一条数据 id相同则修改
     * @author LiuChangLan
     * @since 2020/10/21 17:20
     */
    void createDoc(String indice,String docName){
        Map<String,Object> param = new HashMap<String, Object>();
        ClientOptions clientOptions = new ClientOptions();
        // id字段
        clientOptions.setIdField("id");
        // 是否刷新
        clientOptions.setRefresh("true");
        param.put("id",1);
        param.put("name","张三");
        param.put("age",16);
        String s = bbossESStarter.getRestClient().addDocument(indice, docName, param, clientOptions);
    }

    /**
     * @description 删除文档
     * @author LiuChangLan
     * @since 2020/10/22 9:36
     */
    void delete(String indice,String docName,String id){
        bbossESStarter.getRestClient().deleteDocument(indice,docName,id);
    }

    /**
     * @description es查询
     * @author LiuChangLan
     * @since 2020/10/22 9:36
     */
    void select(){
        ClientInterface restClient = ElasticSearchHelper.getConfigRestClientUtil("elasticsearch/demo.xml");
        ESDatas<Map> mapESDatas = restClient.searchList("archives/_search", "query", null, Map.class);
        System.out.println(JSON.toJSONString(mapESDatas));
    }
}
